; Crunch bitmap decoder
; /Mic, 2002


.686p
.MODEL FLAT, STDCALL
OPTION CASEMAP:NONE 		; Case sensitive


include windows.inc
include kernel32.inc
includelib kernel32.lib


;######################## Macros ########################

TRIGGER	equ 0FEh

return MACRO arg
 	mov eax, arg
 	ret
ENDM


DC_YUV411_TO_RGB24_UPDATE_EDI MACRO
	.if ecx == 0
		inc edi
		inc ys_written_mod4
		.if ys_written_mod4 == 4
			add edi,2
			mov ys_written_mod4,0
		.endif
	.else
		add edi,6
	.endif
ENDM



; Convert YUV to RGB and store at EDI
;
YUV_TO_RGB MACRO Y,U,V
	push esi
	sub Y,16 
	imul Y,4767 
		
	mov temp,Y 		
	mov eax,6537 
	imul V 
	add eax,temp 
	xor esi,esi
	sar eax,12 
	cmp eax,0 
	cmovl eax,esi
	mov esi,255
	cmp eax,255 
	cmovg eax,esi
	mov [edi],al 
		
	mov eax,1601 
	imul U 
	mov esi,temp 
	sub esi,eax 
	mov eax,3330 
	imul V 
	sub esi,eax 
	mov eax,esi 
	sar eax,12
	xor esi,esi
	cmp eax,0 
	cmovl eax,esi
	mov esi,255
	cmp eax,255 
	cmovg eax,esi
	mov [edi+1],al

	mov eax,8266 
	imul U 
	add eax,temp 
	sar eax,12
	xor esi,esi
	cmp eax,0 
	cmovl eax,esi
	mov esi,255
	cmp eax,255 
	cmovg eax,esi 
	mov [edi+2],al 
	pop esi
ENDM

;######################### Data #########################

.data
	yuv411buffer	dd NULL

	
.data?

	temp dd ?
	

;######################## Code ##########################

.code


AllocYUV411Buffer PROC bmSize:DWORD
	pusha
	
	mov eax,bmSize
	add eax,eax
	invoke LocalAlloc,LPTR,eax
	.if eax == NULL
		popa
		return FALSE
	.endif
	
	mov yuv411buffer,eax
	popa
	return TRUE
AllocYUV411Buffer ENDP



FreeYUV411Buffer PROC
	.if yuv411buffer != NULL
		invoke LocalFree, yuv411buffer
		mov yuv411buffer,NULL
	.endif
	ret
FreeYUV411Buffer ENDP



DeCrunch_YUV444_TO_RGB24 PROC compressed:DWORD,dest:DWORD
	local streamlength:DWORD,maxlen:DWORD
	
	pusha 
	mov esi,compressed 
	mov temp,esi 
	add esi,12 
	mov ecx,0 
	@@outer: 
		mov edi,dest 
		add edi,ecx 
		xor edx,edx 
		mov streamlength,edx 		; streamlength = 0
		@@inner:
			mov eax,temp		
			cmp edx,[eax+ecx*4] 
			jnb @@end_inner 
			movzx eax,byte ptr [esi+edx] 
			inc edx 
			.if eax == TRIGGER 
				movzx ebx,byte ptr [esi+edx] 
				inc edx 
				.if ebx == 0
					mov [edi],al 
					add edi,3 
					inc dword ptr streamlength
					jmp @@end_if 
				.else
					movzx eax,byte ptr [esi+edx] 
					inc edx 
					@@repeat: 
						mov [edi],al 
						add edi,3 
						inc dword ptr streamlength
						dec ebx
					jnz @@repeat 
					jmp @@end_if 
				.endif
			.endif 
				mov [edi],al 
				add edi,3 
				inc dword ptr streamlength
			@@end_if: 
			.if ecx == 2 
				mov eax,streamlength
				cmp eax,maxlen
				jge @@end_inner 
			.endif
		jmp @@inner 
		@@end_inner: 
		.if ecx == 0 
			mov eax,streamlength
			mov maxlen,eax 
		.endif
		add esi,edx 
		inc ecx 
		cmp ecx,3 
	jne @@outer 

	mov ecx,streamlength
	lea ecx,[ecx+ecx*2] 
	mov edi,dest
	add edi,ecx 
	xor ecx,-1 
	inc ecx 
	@@yuv2rgb: 
		mov esi,ecx 
		movzx eax,word ptr [edi+esi] 
		add esi,2 
		mov ebx,eax 
		movzx ebp,byte ptr [edi+esi] 
		and eax,255 
		shr ebx,8 
		sub eax,16 
;		mov esi,4767 
		imul eax,4767 
		sub ebx,128		; ebx = U 
		sub ebp,128		; edx = V
		
		mov temp,eax 		; temp = Y
		mov eax,6537 
		imul ebp 
		add eax,temp 
		xor esi,esi
		sar eax,12 
		cmp eax,0 
		IFNDEF _USE_CMOV_
		jnl @@redOK1 
		xor eax,eax 
		@@redOK1: 
		ELSE
		ECHO  Using Conditional MOVs
		cmovl eax,esi
		ENDIF
		mov esi,255
		cmp eax,255 
		IFNDEF _USE_CMOV_
		jnge @@redOK2 
		mov eax,255 
		@@redOK2: 
		ELSE
		cmovg eax,esi
		ENDIF
		mov [edi+ecx],al 
		inc ecx 
		
		mov eax,1601 
		imul ebx 
		mov esi,temp 
		sub esi,eax 
		mov eax,3330 
		imul ebp 
		sub esi,eax 
		mov eax,esi 
		sar eax,12
		xor esi,esi
		cmp eax,0 
		cmovl eax,esi
		mov esi,255
		cmp eax,255 
		cmovg eax,esi
		mov [edi+ecx],al
		inc ecx 

		mov eax,8266 
		imul ebx 
		add eax,temp 
		sar eax,12
		xor esi,esi
		cmp eax,0 
		cmovl eax,esi
		cmp eax,255 
		jng @@blueOK2 
		mov eax,255 
		@@blueOK2: 
		mov [edi+ecx],al 
		inc ecx 
	jnz @@yuv2rgb 
	popa 
	ret
DeCrunch_YUV444_TO_RGB24 ENDP





DeCrunch_YUV411_TO_RGB24 PROC compressed:DWORD,dest:DWORD,bmWidth:DWORD
	local streamlength:DWORD,maxlen:DWORD,ys_written_mod4:DWORD
	local chroma1:DWORD,chroma2:DWORD,counter:DWORD,loopvar:DWORD,onerow:DWORD
	
	pusha

	mov esi,compressed 
	mov temp,esi 
	add esi,12 
	mov ecx,0 
	@@DC2_outer: 
		mov edi,yuv411buffer
		.if ecx == 1
			add edi,4
		.elseif ecx == 2
			add edi,5
		.else
			mov ys_written_mod4,0
		.endif
		xor edx,edx 
		mov streamlength,edx 		; streamlength = 0
		@@DC2_inner:
			mov eax,temp		
			cmp edx,[eax+ecx*4] 
			jnb @@DC2_end_inner 
			movzx eax,byte ptr [esi+edx] 
			inc edx 
			.if eax == TRIGGER 
				movzx ebx,byte ptr [esi+edx] 
				inc edx 
				.if ebx == 0
					mov [edi],al 
					DC_YUV411_TO_RGB24_UPDATE_EDI
					inc dword ptr streamlength
					jmp @@DC2_end_if 
				.else
					movzx eax,byte ptr [esi+edx] 
					inc edx 
					add streamlength,ebx
					@@DC2_repeat: 
						mov [edi],al 
						DC_YUV411_TO_RGB24_UPDATE_EDI 
						dec ebx
					jnz @@DC2_repeat 
					jmp @@DC2_end_if 
				.endif
			.endif 
				mov [edi],al 
				DC_YUV411_TO_RGB24_UPDATE_EDI 
				inc dword ptr streamlength
			@@DC2_end_if: 
			.if ecx == 2 
				mov eax,streamlength
				cmp eax,maxlen
				jge @@DC2_end_inner 
			.endif
		jmp @@DC2_inner 
		@@DC2_end_inner: 
		.if ecx == 1 
			mov eax,streamlength
			mov maxlen,eax 
		.endif
		add esi,edx 
		inc ecx 
		cmp ecx,3 
	jne @@DC2_outer 

	
	mov eax,bmWidth
	lea eax,[eax+eax*2]
	mov onerow,eax			; Size of one row (in bytes)
	mov counter,0
	mov esi,yuv411buffer
	mov edi,dest
		
	@@DC2_yuv2rgb:
		movzx eax,byte ptr [esi] 	; Get Y0
		movzx ebx,word ptr [esi+4] 
		mov ecx,ebx 
		and ebx,255 			; ebx = U0
		shr ecx,8 			; ecx = V0
		sub ebx,128		 
		sub ecx,128		

		YUV_TO_RGB eax,ebx,ecx
		add edi,3
		movzx eax,byte ptr [esi+1]	; Get Y1
		YUV_TO_RGB eax,ebx,ecx
		push edi
		sub edi,3
		movzx eax,byte ptr [esi+2]	; Get Y2
		add edi,onerow
		YUV_TO_RGB eax,ebx,ecx
		add edi,3
		movzx eax,byte ptr [esi+3]	; Get Y3
		YUV_TO_RGB eax,ebx,ecx
		
		pop edi
		add esi,6
		add edi,3
		
		add counter,2
		mov eax,bmWidth
		.if counter == eax
			add edi,onerow
			mov counter,0
		.endif
	
		dec dword ptr streamlength
	jnz @@DC2_yuv2rgb 
	
	popa
	ret
DeCrunch_YUV411_TO_RGB24 ENDP




DeCrunch PROC compressed:DWORD,dest:DWORD,bmWidth:DWORD,method:DWORD
	pusha
	cld

	.if method == 0
		invoke DeCrunch_YUV444_TO_RGB24, compressed,dest
	.elseif method == 1
		invoke DeCrunch_YUV411_TO_RGB24, compressed,dest,bmWidth
	.endif

	popa
	ret
DeCrunch ENDP



END

