;############################### DRVPROC.ASM #############################

; /Mic, 2002
; stabmaster_@hotmail.com | http://www.cyd.liu.se/~micol972/site/


; Compile with MASM:
;
;   ml /c /coff drvproc.asm


    .386
    .model flat, stdcall
    option casemap :none   ; case sensitive


;#########################################################################

    include windows.inc
    include kernel32.inc
    include user32.inc
    include .\vfw32.inc
    include winmm.inc
    
    includelib kernel32.lib
    includelib user32.lib
    includelib winmm.lib
 
;#########################################################################

 	return MACRO arg
 		mov eax, arg
 		ret
 	ENDM

	switch MACRO what
		mov eax,what
	ENDM
	
	case MACRO what
		cmp eax,what
		jne @@_end_case_$what
	ENDM
	
	endcase MACRO what
		@@_end_case_$what:
	ENDM
	
;##########################################################################

	CodecOpen PROTO :DWORD
	CodecClose PROTO :DWORD
	CodecGetInfo PROTO :DWORD,:DWORD

	CodecQueryCompress PROTO :DWORD,:DWORD
	CodecBeginCompress PROTO :DWORD,:DWORD
	CodecGetCompressFormat PROTO :DWORD,:DWORD
	CodecGetCompressSize PROTO :DWORD,:DWORD
	CodecCompress PROTO :DWORD,:DWORD
	CodecEndCompress PROTO
	
	CodecQueryDecompress PROTO :DWORD,:DWORD
	CodecQueryDecompressEx PROTO :DWORD
	CodecBeginDecompress PROTO :DWORD,:DWORD
	CodecGetDecompressFormat PROTO :DWORD,:DWORD
	CodecDecompress PROTO :DWORD,:DWORD
	CodecEndDecompress PROTO
	
        wsprintfA PROTO C :DWORD, :VARARG
        wsprintf equ <wsprintfA>	

;##########################################################################

.data

	hmoduleCodec	dd	0
	szErrorTitle	db 	'Error',0
	szErrorInfo	db	'Unhandled message:',0,0,0,0,0,0,0,0,0
	szFormatError	db	'Unhandled message: %d',0


;##########################################################################

.code

LibMain PROC hInstDLL:DWORD, reason:DWORD, unused:DWORD


        .if reason == 1		;DLL_PROCESS_ATTACH

		mov eax,hInstDLL
		mov hmoduleCodec,eax
		return TRUE

        .elseif reason == 0	;DLL_PROCESS_DETACH
        .elseif reason == 2	;DLL_THREAD_ATTACH
        .elseif reason == 3	;DLL_THREAD_DETACH
        .endif

        return FALSE

LibMain ENDP

; ##########################################################################


;***************************************************************************
;* DriverProc  -  The entry point for an installable driver.
;*
;* PARAMETERS
;* dwDriverId:  For most messages, <dwDriverId> is the DWORD
;*     value that the driver returns in response to a <DRV_OPEN> message.
;*     Each time that the driver is opened, through the <DrvOpen> API,
;*     the driver receives a <DRV_OPEN> message and can return an
;*     arbitrary, non-zero value. The installable driver interface
;*     saves this value and returns a unique driver handle to the
;*     application. Whenever the application sends a message to the
;*     driver using the driver handle, the interface routes the message
;*     to this entry point and passes the corresponding <dwDriverId>.
;*     This mechanism allows the driver to use the same or different
;*     identifiers for multiple opens but ensures that driver handles
;*     are unique at the application interface layer.
;*
;*     The following messages are not related to a particular open
;*     instance of the driver. For these messages, the dwDriverId
;*     will always be zero.
;*
;*         DRV_LOAD, DRV_FREE, DRV_ENABLE, DRV_DISABLE, DRV_OPEN
;*
;* hDriver: This is the handle returned to the application by the
;*    driver interface.
;*
;* uiMessage: The requested action to be performed. Message
;*     values below <DRV_RESERVED> are used for globally defined messages.
;*     Message values from <DRV_RESERVED> to <DRV_USER> are used for
;*     defined driver protocols. Messages above <DRV_USER> are used
;*     for driver specific messages.
;*
;* lParam1: Data for this message.  Defined separately for
;*     each message
;*
;* lParam2: Data for this message.  Defined separately for
;*     each message
;*
;* RETURNS
;*   Defined separately for each message.
;*
;***************************************************************************

DriverProc PROC dwDriverID:DWORD, hDriver:DWORD, uiMessage:DWORD, lParam1:DWORD, lParam2:DWORD
; pi = CodecInst* dwDriverID

	mov eax,uiMessage
	
	.if eax == DRV_LOAD
		return 1
	
	.elseif eax == DRV_FREE
		return 1

	.elseif eax == DRV_OPEN
		invoke CodecOpen,lParam2
		ret

	.elseif eax == DRV_CLOSE
		; if (pi) Close(pi)
		return 1;

	.elseif eax == DRV_QUERYCONFIGURE
		return 1
	
	.elseif eax == DRV_CONFIGURE
		return DRV_OK
		
 ;-------------------------------------------------------------------
 
	.elseif eax == ICM_CONFIGURE
		return ICERR_UNSUPPORTED	; no configuration box
		
	.elseif eax == ICM_ABOUT
		return ICERR_UNSUPPORTED	; no about box either
		
	.elseif eax == ICM_GETSTATE
		return 0
		
	.elseif eax == ICM_SETSTATE
		return 0
		
	.elseif eax == ICM_GETINFO
		invoke CodecGetInfo,lParam1,lParam2
		ret
		
	.elseif eax == ICM_GETDEFAULTQUALITY
		mov eax,lParam1
		.if eax != 0
			mov ebx,7500
			mov [eax],ebx
			return ICERR_OK
		.endif
		return ICERR_UNSUPPORTED

;----------------------------------------------------------------------
	
	.elseif eax == ICM_COMPRESS_QUERY
		invoke CodecQueryCompress,lParam1,lParam2
		ret
		
	.elseif eax == ICM_COMPRESS_BEGIN
		invoke CodecBeginCompress,lParam1,lParam2
		ret
	
	.elseif eax == ICM_COMPRESS_GET_FORMAT
		invoke CodecGetCompressFormat,lParam1,lParam2
		ret
		
	.elseif eax == ICM_COMPRESS_GET_SIZE
		invoke CodecGetCompressSize,lParam1,lParam2
		ret
		
	.elseif eax == ICM_COMPRESS
		invoke CodecCompress,lParam1,lParam2
		ret
		
	.elseif eax == ICM_COMPRESS_END
		invoke CodecEndCompress
		ret
		
;----------------------------------------------------------------------

	.elseif eax == ICM_DECOMPRESS_QUERY
		invoke CodecQueryDecompress,lParam1,lParam2
		ret

	.elseif eax == ICM_DECOMPRESSEX_QUERY
		invoke CodecQueryDecompressEx,lParam1
		ret
		
	.elseif eax == ICM_DECOMPRESS_BEGIN
		invoke CodecBeginDecompress,lParam1,lParam2
		ret
	
	.elseif eax == ICM_DECOMPRESS_GET_FORMAT
		invoke CodecGetDecompressFormat,lParam1,lParam2
		ret
		
	.elseif eax == ICM_DECOMPRESS_GET_PALETTE
		return ICERR_BADFORMAT
		
	.elseif eax == ICM_DECOMPRESS
		invoke CodecDecompress,lParam1,lParam2
		ret
		
	.elseif eax == ICM_DECOMPRESS_END
		invoke CodecEndDecompress
		ret

;----------------------------------------------------------------------

	.elseif eax == DRV_ENABLE
		return 1
	
	.elseif eax == DRV_DISABLE
		return 1
	
	.elseif eax == DRV_INSTALL
		return DRV_OK
		
	.elseif eax == DRV_REMOVE
		return DRV_OK
		
	.elseif eax < DRV_USER
		invoke DefDriverProc,dwDriverID,hDriver,uiMessage,lParam1,lParam2
		ret
		
	.endif
	
	IFDEF _DEBUG_
	invoke wsprintf,ADDR szErrorInfo,ADDR szFormatError,uiMessage
	invoke MessageBox,NULL,ADDR szErrorInfo,ADDR szErrorTitle,MB_ICONERROR
 	ENDIF

	return ICERR_UNSUPPORTED

DriverProc ENDP


; ##########################################################################

End LibMain
